import { Metadata, Http } from '@zeedhi/core';
import { Modal, ModalService } from '@zeedhi/common';
import { TekGrid } from '@zeedhi/teknisa-components-common';

export class AFDeliveryLastYearModalController {
  private aFDeliveryLastYearModal!: Modal;
  
  private daySelected: string = '';

  public async createAFDeliveryLastYearModal() {
    this.aFDeliveryLastYearModal = await ModalService.createFromJson('/modals/aFDeliveryLastYearModal', true);
  }

  public destroyAFDeliveryLastYearModal() {
    this.aFDeliveryLastYearModal?.destroy();
  }

  public async openAFDeliveryLastYearModal({ component, config }) {
    const gridRoute = component.options.props.gridRoute;
    this.daySelected = component.options.xaxis.categories[config.dataPointIndex];
    await this.aFDeliveryLastYearModal.show();
    const gridGroup = Metadata.getInstance<TekGrid>('aFDeliveryLastYearGrid');

    const queryString = 'requestType=FilterData';

    Http.get(`/${gridRoute}?${queryString}`).then(({ data }) => {
      gridGroup.datasource.updateData(data.dataset.aFDeliveryLastYearGrid);
    });
  }

  public closeAFDeliveryLastYearModal() {
    this.aFDeliveryLastYearModal.hide();
  }
}
